<?php
Namespace App\Controller\Admin\Maintenance;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use App\Model\Admin\HomegearUpdate;
use App\Utils\Utils;

class UpdateController extends Controller
{
    public function indexAction(Request $request, HomegearUpdate $updates, Utils $utils)
    {
        $now = time();
        $lastUpdateCheck = $updates->getLastUpdateCheck();
        return $this->render('Admin/Maintenance/Updates/list.html.twig', array(
            'sect' => $request->attributes->get('sect'),
            'mgmt' => $utils->checkManagementRunning(),
            'updates' => $updates->list(),
            'lastUpdateCheck' => $lastUpdateCheck,
            'doCheck' => ($now - $updates->getLastUpdateCheck()) > 3600
        ));
    }

    public function updateAction($type, Request $request, HomegearUpdate $updates)
    {
        $result = $updates->update($type);
        return new JsonResponse($result);
    }

    public function checkAction(Request $request, HomegearUpdate $update)
    {
        $result = $update->check();
        return new JsonResponse($result);
    }
}