<?php
namespace App\Security\User;

use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Security\Core\User\EquatableInterface;

class HomegearUser implements UserInterface, EquatableInterface
{
    private $username;
    private $password;

    public function __construct($username, $password, $locale, $afterLogin, $room, $story, array $roles, $authorized)
    {
        $this->username = $username;
        $this->password = $password;
        $this->locale = $locale;
        $this->afterLogin = $afterLogin;
        $this->room = $room;
        $this->story = $story;
        $this->authorized = $authorized;
    }

    public function getUsername()
    {
        return $this->username;
    }

    public function getRoles()
    {
        return array('ROLE_ADMIN');
    }

    public function getPassword()
    {
        return $this->password;
    }

    public function getSalt()
    {
        return;
    }

    public function getLocale() {
        return $this->locale;
    }

    public function getAfterLogin() {
        return $this->afterLogin;
    }

    public function getRoom() {
        return $this->room;
    }

    public function getStory() {
        return $this->story;
    }

    public function getAuthorized() {
        return $this->authorized;
    }

    public function eraseCredentials()
    {
        return;
    }
    
    public function isEqualTo(UserInterface $user)
    {
        if (!$user instanceof HomegearUser) {
            return false;
        }

        if ($this->password !== $user->getPassword()) {
            return false;
        }

        if ($this->username !== $user->getUsername()) {
            return false;
        }

        return true;
    }
}
