<?php
namespace App\Utils;

use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\RequestMatcher;
use Symfony\Component\Filesystem\Filesystem;
use App\Utils\Utils;
use \Homegear\Homegear as Homegear;

class Checkpassword
{
    protected $hg;

    public function __construct()
    {
        $this->hg = new Homegear;
    }

    public function check($request)
    {
        // get the data-path
        if (call_user_func("Homegear\\Homegear::system.listMethods", "managementGetCommandStatus")) {
            // homegear-management is running and doing nothing else, so use it
            try {
                $hgPath = $this->hg->managementGetConfigurationEntry('main.conf','writeableDataPath');
                if (!$hgPath || $hgPath == '') {
                    $hgPath = $this->hg->managementGetConfigurationEntry('main.conf','dataPath');    
                }
            } catch(\Homegear\HomegearException $e) {
                // something went wrong, let's do it the classic way
                $hgPath = $this->_getDataPath();
            }
        } else {
            // homegear-management is not running or busy right now, so let's do it the classic way
            $hgPath = $this->_getDataPath();
        }
        $fs = new Filesystem();
        if ($fs->exists($hgPath.'/defaultPassword.txt')) {
            $matcher = new RequestMatcher();
            $matcher->matchPath('/changepwd');
            if ($matcher->matches($request) === false) {
                $response = new RedirectResponse('/admin/changepwd');
                $response->send();
            }
        }
    }

    private function _getDataPath()
    {
        $conf = file_get_contents('/etc/homegear/main.conf');
        preg_match('/^writeableDataPath = (.+)/m',$conf,$result);
        if (!is_array($result) || count($result) < 1) {
            preg_match('/^dataPath = (.+)/m',$conf,$result);
        }
        return $result[1];
    }
}